// Braille printer firmware 0.0
// Created by, Haydn Jones 2017
// https://hackaday.io/project/20239-braille-printer
// Serial read code by [Neil Cherry]
//
// Creative commons licence (CC BY 4.0)
// https://creativecommons.org/licenses/by/4.0/
// Do whatever you like with the code, just credit me please :)
//
// thanks to [Jørgen Kragh Jakobsen], [Neil Cherry] for helping me with understanding
// binary variables
//
//////////////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////////////
// Wireing instructions
// 
//
//
//////////////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////////////
//Features, operating and develpoing notes
//
//will add a resistor, model number check, so a single firmware can be uesd for many
//printer configurations, just changing a few key variables.
//
//28BYJ-48 Stepper Motor and ULN2003 Driver
//sg 90 servo
//
//////////////////////////////////////////////////////////////////////////////////////

//notes 
  //uint8_t make int 8bit

//Includes  
#include <Servo.h>
#include <AccelStepper.h>

// pin wireing
  //sensors
int endPin = 19; // endstop pin
int paperPin = 18; // paper load sensor pin
int doorPin = 15; // door open pin

  //steppers
#define xmotorpin1 4
#define xmotorpin2 5
#define xmotorpin3 6
#define xmotorpin4 7
AccelStepper stepperX(4, xmotorpin1, xmotorpin3, xmotorpin2, xmotorpin4);

#define ymotorpin1 8
#define ymotorpin2 9
#define ymotorpin3 10
#define ymotorpin4 11
AccelStepper stepperY(4, ymotorpin1, ymotorpin3, ymotorpin2, ymotorpin4);
  
  //servo
Servo dotServo; 

  //control panel
int feedPin = 17; // button manual paper feed 
int printTest = 16; // button prints a test page using all modes
// int a4 mode..... for non continuous roll printing add later

  //direct keyboard pins (brailler type) mode tbc
  
  //stepper comtrol

  //serial read ints
int incomingVal = 0;
int incomingCount = 0;
int incomingSum = 0;
int incomingByte() {
  while(1) {
    if(Serial.available() > 0) {
      // Should check that it's between '0' & '9' inclusive
      // or ('0' and '9') or ('a' and 'f') if hex
      return(Serial.read() - '0'); // 0 ASCII is 0x30 hex or 48 Decimal
    }
  }
}

  
//sensor and key state
int endpinVal = 0;
int paperpinVal = 0;
int feedpinVal = 0;
int printtestVal = 0;
int doorpinVal = 0;


// mechanical variables
// more servo stuff to add?? Maybe relay/actuator

int xmotorSpeed = 1200; //guessing here
int ymotorSpeed = 1200; //guessing here
int xSteps = 0; //current actions steps X-stepper
int ySteps = 0; //current actions steps Y-stepper
int stepsTable[4] = {B0011, B0110, B1100, B1001};
int paperIn = 0; // checks for paper
int endStop = 0; // for setting line acess zero position
int dotPress = 50; // servo press position
int dotHome = 15; // servo home position

//set modes
int printingMode = 0; //sets for braille standard/large mode, moon mode, graphics mode, etc
int endMode = 0; //sets end of mode and waits for new mode

// braille modes print variables
int cellCount = 0; // counts line postition
int cellMax = 40; // maximum line lengh till automatically word wraping
int vertNextDot = 20; // vertical step count to dot in braille cell X-STEPPER
int horizNextDot = 20; // horizontal step count to second colum of braille cell X-STEPPER
int nextCell = 20; // horizontal step count top left of next braille cell X-STEPPER
int wholeCellSpace = 40; // cell including space, as if space bar is pressed x-stepper
int lineStart = 0; // horizontal movement to line start, calculated from cellCount*cellSpace X-STEPPER
int nextLine =  160; // step count move vertically to next line from top left cell to top left cell Y-STEPPER


// braille size format values, sets braille mode print values
int standard1 = 0;
int standard2 = 0;
int standard3 = 0;
int standard4 = 0;
int standard5 = 0;
int standard6 = 0;
int standard7 = 0;
int standard8 = 0;
int large1 = 0;
int large2 = 0;
int large3 = 0;
int large4 = 0;
int large5 = 0;
int large6 = 0;
int large7 = 0;
int large8 = 0;

//braille bits
int bit1 = 0;
int bit2 = 0;
int bit3 = 0;
int bit4 = 0;
int bit5 = 0;
int bit6 = 0;

//Braille mode charactor variables
uint8_t chartoPrint = 0; // set from 0 to 65. 0 is space, 65 is return.
    //define all chars
int returnKey = 0;
int spaceKey = 0;
// ignor this for now // int charLookup[64] =  {B000000, B000001, B000010, B000011, B000100, B000101, B000110, B000111, B001000, B001001, B001010, B001011, B001100, B001101, B001110, B001111, B010000, B010001, B010010, B010011, B010100, B010101, B010110, B010111, B011000, B011001, B011010, B011011, B011100, B011101, B011110, B011111, B100000, B100001, B100010, B100011, B100100, B100101, B100110, B100111, B101000, B101001, B101010, B101011, B101100, B101101, B101110, B101111, B110000, B110001, B110010, B110011, B110100, B110101, B110110, B110111, B111000, B111001, B111010, B111011, B111100, B111101, B111110, B111111};

// braille mode lookup 0=space 64=return 256=end
// "braille printer v0.1
//  firmware v0.1
//  The quick bron fox...." 
// line, line , end mode
uint8_t test1Lookup[20] = {1, 2, 3, 4, 0, 5, 6, 7, 8, 9, 64, 1, 2, 3, 4, 0, 5, 6, 7, 8,};


void setup() {
  Serial.begin(9600); // set serial monitor
  //setup keys and sensors as inputs
  pinMode(endPin, INPUT_PULLUP);
  pinMode(paperPin, INPUT_PULLUP);
  pinMode(feedPin, INPUT_PULLUP);
  pinMode(printTest, INPUT_PULLUP);
  pinMode(doorPin, INPUT_PULLUP);
  
  // put your setup code here, to run once:
  // set pinModes
     //servo for dot punch
   dotServo.attach(14);
     // stepper X
     stepperX.setMaxSpeed(2000);
     stepperX.setAcceleration(200);
     // stepper Y
     stepperY.setMaxSpeed(2000);
     stepperY.setAcceleration(200);

}

void loop() {

    //read input values
  endpinVal = digitalRead(endPin);
  paperpinVal = digitalRead(paperPin);
  feedpinVal = digitalRead(feedPin);
  printtestVal = digitalRead(printTest);
  doorpinVal = digitalRead(doorPin);

  //set servo home
  dotServo.write(dotHome);
  
  //set Y home
  if (endpinVal == LOW) {
  xSet();
    //run x stepper untill further notice to do == LOW
  }  
  //check paper load
  if (paperpinVal == HIGH) {
    //run y stepper untill further notice to do == LOW
//        digitalWrite(ymotorPins[pin],steps[directionStep][pin]);
//    currentStep = 0; 
//    delay(3);
  }
  //check paper feed
  if (feedpinVal == LOW) {
    //run y stepper untill further notice to do == HIGH
  }
  //check test mode to do
  if (printtestVal == LOW) {
  testMode();
  } 
  
  if (incomingSum == 100){
  printingMode = 1;
  Serial.println("braille mode active");
  }
  
  incomingSum = 0; // Okay now we're done with it, reset it
  
  //check serial to do, send serial on anouncement to state that printer is ready
  if  (endpinVal == HIGH) {
  Serial.println ("Ready");
  getSerial();
  }
  


  
  //printing modes
  if (printingMode == 1) {
  brailleMode();
  }
}
     


void getSerial(){
    // read incoming commands
  // it's a 3 byte value (but serial reads ints)
  for(incomingCount = 0; incomingCount < 3; incomingCount++) {
    incomingVal = incomingByte();

    incomingSum = incomingSum * 10;
    incomingSum += incomingVal;
    Serial.print(incomingVal);
  }
  Serial.println("...");
  Serial.print("Check: ");
  Serial.println(incomingSum);
  // add switches???
  if (printingMode == 1) {
    chartoPrint = incomingSum;
    incomingSum = 0;
    brailleMode();
  }
  loop();
}

void testMode(){
  //insert test pattern here
}

void brailleMode(){

    // put your main code here, to run repeatedly:
  //request next over serial
  //set braille mode scale
  //look for end mode
  //

    
  // check for space, then charSpace
    if (chartoPrint == 0) {
        Serial.println ("space");
  charSpace();
  }
  // check for return, then lineReturn
      if (chartoPrint == 64) {
  lineReturn();
      }
  // check for max, then lineReturn
          if (cellCount == 24) {//24 is a guess, way off really
  lineReturn();
      }
  // check printing charactor, then charPrint
        if ((chartoPrint > 0) && (chartoPrint < 64)) {// 1 to 63
          Serial.println ("Braille Cell");
  charPrint();
      }
}

void charPrint(){
  cellCount = (cellCount+1); 
  bit1 = bitRead(chartoPrint,0);
  bit2 = bitRead(chartoPrint,1);
  bit3 = bitRead(chartoPrint,2);
  bit4 = bitRead(chartoPrint,3);
  bit5 = bitRead(chartoPrint,4);
  bit6 = bitRead(chartoPrint,5);
  // dots 1,2,3 then next coloum then dots6,5,4 (down, then up)then accross to next cell
  Serial.print(bit1);
  Serial.print(bit2);
  Serial.print(bit3);
  Serial.print(bit4);
  Serial.print(bit5);
  Serial.println(bit6);
  
  //if 
    //1
    dotServo.write(dotPress*bit1);
    delay(600*bit1);
    dotServo.write(dotHome*bit1);
    delay(600*bit1);
    stepperY.move(vertNextDot);
    stepperY.runToPosition();
    delay(600);
    //2    
    dotServo.write(dotPress*bit2);
    delay(600*bit2);
    dotServo.write(dotHome*bit2);
    delay(600*bit2);
    stepperY.move(vertNextDot);
    stepperY.runToPosition();
    delay(600);
    //3
    dotServo.write(dotPress*bit3);
    delay(600*bit3);
    dotServo.write(dotHome*bit3);
    delay(600*bit3);
    stepperX.move(horizNextDot);
    stepperX.runToPosition();
    delay(600);
    //next colum
    //6
    dotServo.write(dotPress*bit6);
    delay(600*bit4);
    dotServo.write(dotHome*bit6);
    delay(600*bit4);
    stepperY.runToPosition();
    delay(600);
    //5
    dotServo.write(dotPress*bit5);
    delay(600*bit5);
    dotServo.write(dotHome*bit5);
    delay(600*bit5);
    stepperY.move(-vertNextDot);
    stepperY.runToPosition();
    delay(600);
    //4
    dotServo.write(dotPress*bit4);
    delay(600*bit4);
    dotServo.write(dotHome*bit4);
    delay(600*bit4);
    //next cell
    stepperX.move(nextCell);
    stepperX.runToPosition();
    delay(600);
    if (cellCount == 40) {
    lineReturn();
  }
}

void lineReturn(){
  stepperY.move(nextLine);
  stepperY.runToPosition();
  stepperX.move(-wholeCellSpace*cellCount);
  stepperX.runToPosition();
  Serial.println ("Return");
  cellCount = 0;
}

void charSpace(){
    cellCount = (cellCount+1); 
    stepperX.move(wholeCellSpace);
    stepperX.runToPosition();
    if (cellCount == 40) {
    lineReturn();
  }
    
}

void xSet() {
  Serial.println("endpin");
    stepperX.move(300);
    stepperX.run();
  while (endpinVal == HIGH);
}
